package main

import (
	"amazon"
	"fmt"
	"mlist"
)

// HasLength is any type with an associated Length() method that returns an int
type hasLength interface {
	Length() int
}

func averageLength(x []hasLength) float64 {
	var sum int
	for _, b := range x {
		sum += b.Length()
	}
	return float64(sum) / float64(len(x))
}

/*
func cerca(x []interface{}, y interface{}) int {
	for i, t := range x {
		if t == y {
			return i
		}
	}
	return -1
}*/

func main() {
	var x mlist.List
	x = x.AddInOrder("pippo")
	x = x.AddInOrder("pluto")
	x = x.AddInOrder("topolino")
	x = x.AddInOrder("ultimo")
	x = x.AddInOrder("abate")
	x = x.AddInOrder("ragno")
	x.PrintWithArrows()
	fmt.Printf("Lunghezza della lista: %d\n", x.Length())

	fmt.Println(x)

	var scatola amazon.Box
	scatola = amazon.Box{30, 20, 15}

	fmt.Printf("Volume della scatola: %d\n", scatola.Volume())
	fmt.Printf("Lunghezza della scatola: %d\n", scatola.Length())

	var y []hasLength
	y = append(y, amazon.Box{30, 20, 10})
	y = append(y, amazon.Box{50, 25, 15})
	y = append(y, x)
	y = append(y, amazon.Box{32, 20, 15})

	fmt.Printf("Lunghezza media: %.2f\n", averageLength(y))

	fmt.Println(scatola)
}
